package cn.com.ctop.kuaishou.modules.ai.service.impl;

import cn.com.ctop.common.module.entity.UserAllocation;
import cn.com.ctop.common.module.service.IUserAllocationService;
import cn.com.ctop.common.module.utils.HttpUtils;
import cn.com.ctop.common.module.utils.ResultMapUtils;
import cn.com.ctop.common.module.utils.StatusCode;
import cn.com.ctop.kuaishou.modules.ai.entity.AiKuaishouAdvertiserStrategy;
import cn.com.ctop.kuaishou.modules.ai.mapper.AiKuaishouAdvertiserStrategyMapper;
import cn.com.ctop.kuaishou.modules.ai.service.IAiKuaishouAdvertiserStrategyService;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.Map;

/**
 * 快手账户策略设置信息表
 * @author jeecg-boot
 * @date   2021-01-25
 * @version V1.0
 */
@Service
public class AiKuaishouAdvertiserStrategyServiceImpl extends ServiceImpl<AiKuaishouAdvertiserStrategyMapper, AiKuaishouAdvertiserStrategy> implements IAiKuaishouAdvertiserStrategyService {
    public static final String TEST_CREATIVE_URL= "http://139.186.27.96:31012/ai_historical_missing_material";
    public static final String TEST_PROGRAM_CREATIVE_URL= "http://139.186.27.96:31012/ai_programme_new_material";
    @Autowired
    private IUserAllocationService userAllocationService;
    @Override
    public AiKuaishouAdvertiserStrategy getByAccountId(Long accountId) {
        QueryWrapper<AiKuaishouAdvertiserStrategy>queryWrapper =new QueryWrapper<>();
        queryWrapper.eq("account_id",accountId);
        queryWrapper.orderByDesc("id");
        queryWrapper.last("limit 1");
        return this.getOne(queryWrapper);
    }

    @Override
    public Map<String, Object> testCreate(Long accountId) {
        Map<String,Object>result = new HashMap<>();
        if(null == accountId||accountId == 0){
            ResultMapUtils.setResultMap(result, StatusCode.COMMON_PARAM_ERROR);
            return result;
        }
        AiKuaishouAdvertiserStrategy aiKuaishouAdvertiserStrategy = this.getByAccountId(accountId);
        if(null == aiKuaishouAdvertiserStrategy||null == aiKuaishouAdvertiserStrategy.getStatus()||aiKuaishouAdvertiserStrategy.getStatus()!=1){
            ResultMapUtils.setResultMap(result, StatusCode.COMMON_PARAM_ERROR);
            return result;
        }
        UserAllocation allocation = userAllocationService.getByAccountId(accountId);
        if(null == allocation){
            ResultMapUtils.setResultMap(result, StatusCode.COMMON_PARAM_ERROR);
            return result;
        }
        JSONObject params = new JSONObject();
        params.put("account_id",accountId);
        params.put("test_video_cnt",1);
        String request = null;
        //程序化
        if(aiKuaishouAdvertiserStrategy.getOpenProgramCreate() == 1){
            request = HttpUtils.httpPostRequest(TEST_PROGRAM_CREATIVE_URL,params,new HashMap<>());
        }else{
            request = HttpUtils.httpPostRequest(TEST_CREATIVE_URL, params, new HashMap<>());
        }
        JSONObject requestObject = JSONObject.parseObject(request);
        String message = requestObject.getString("message");
        Integer code = requestObject.getInteger("code");
        result.put("code",code);
        result.put("message",message);
        return result;
    }
}
